//----------------------------------------------------------------------//
// NyanFi																//
//  GREPgݒ														//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <Vcl.FileCtrl.hpp>
#include "usr_shell.h"
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "MainFrm.h"
#include "GrepOptDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGrepExOptDlg *GrepExOptDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TGrepExOptDlg::TGrepExOptDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::FormCreate(TObject *Sender)
{
	UserModule->SetUsrPopupMenu(this);

	//Rg[̃^OɁAΉϐ̃|C^ݒ
	OutFileEdit->Tag	   = (int)&GrepFileName;
	AppNameEdit->Tag	   = (int)&GrepAppName;
	AppParamEdit->Tag	   = (int)&GrepAppParam;
	AppDirEdit->Tag 	   = (int)&GrepAppDir;
	FileFmtEdit->Tag	   = (int)&GrepFileFmt;
	InsStrWEdit->Tag	   = (int)&GrepInsStrW;
	InsStrW2Edit->Tag	   = (int)&GrepInsStrW2;
	RepCrEdit->Tag		   = (int)&GrepRepCrStr;
	FExtBakEdit->Tag	   = (int)&FExtRepBackup;
	RepBakDirEdit->Tag	   = (int)&RepBackupDir;
	LogFileEdit->Tag	   = (int)&ReplaceLogName;

	AppendCheckBox->Tag    = (int)&GrepAppend;
	TrimLeftCheckBox->Tag  = (int)&GrepTrimLeft;
	RepTabCheckBox->Tag    = (int)&GrepReplaceTab;
	RepCrCheckBox->Tag	   = (int)&GrepReplaceCr;
	BakRepCheckBox->Tag    = (int)&BackupReplace;
	SaveLogCheckBox->Tag   = (int)&SaveReplaceLog;
	AppendLogCheckBox->Tag = (int)&ReplaceAppend;
	OpenLogCheckBox->Tag   = (int)&OpenReplaceLog;

	OutModeRadioGroup->Tag = (int)&GrepOutMode;

	//hbv^[Qbgݒ
	usr_SH->AddTargetList(this, AppNameEdit);
}
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::FormShow(TObject *Sender)
{
	//^OpăRg[ɒlݒ
	BringOptionByTag(this);

	//
	if (NyanFiForm->GrepPageControl->ActivePage==NyanFiForm->FindSheet) {
		OutModeSheet->TabVisible = true;
		OutFormSheet->TabVisible = true;
		ReplaceSheet->TabVisible = false;
		InsStrWEdit->Enabled	 = true;
		InsStrW2Edit->Enabled	 = true;
	}
	//u
	else {
		OutModeSheet->TabVisible = false;
		OutFormSheet->TabVisible = true;
		ReplaceSheet->TabVisible = true;
		InsStrWEdit->Enabled	 = false;
		InsStrW2Edit->Enabled	 = false;
	}
	SampleChange(NULL);
}

//---------------------------------------------------------------------------
//bv󂯓
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::WmDropped(TMessage &msg)
{
	SetExtNameToCtrl(DroppedList->Strings[0], (TWinControl *)msg.WParam);
}

//---------------------------------------------------------------------------
//o͐̕ύX
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::OutModeRadioGroupClick(TObject *Sender)
{
	FileGroupBox->Enabled = (OutModeRadioGroup->ItemIndex!=2);
}

//---------------------------------------------------------------------------
//o̓t@C̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefOutBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("o̓t@C̎w"), F_FILTER_TXT);
	UserModule->OpenDlgToEdit(OutFileEdit);
	SetFocus();
}

//---------------------------------------------------------------------------
//NAv̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefAppBtnClick(TObject *Sender)
{
	UnicodeString fnam = AppNameEdit->Text;
	UserModule->PrepareOpenDlg(_T("NAvP[V̎w"), F_FILTER_EXE, fnam.c_str(), ExtractFilePath(fnam));
	UserModule->OpenDlgToEdit(AppNameEdit);
	SetFocus();
}
//---------------------------------------------------------------------------
//ƃfBNg̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefDirBtnClick(TObject *Sender)
{
	UnicodeString dnam = GrepAppDir;
	if (UserModule->SelectDirEx(_T("ƃfBNg"), dnam)) AppDirEdit->Text = dnam;
}

//---------------------------------------------------------------------------
//Tv\̍XV
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::SampleChange(TObject *Sender)
{
	SampleMemo->Lines->Clear();

	UnicodeString f_inf = FileFmtEdit->Text;
	if (f_inf.IsEmpty()) f_inf = "$F $L:";

	f_inf = REPLACE_TS(f_inf, "$F", "D:\\hoge.txt");
	f_inf = REPLACE_TS(f_inf, "$L", "123");
	f_inf = conv_esc_char(f_inf);

	std::unique_ptr<TStringList> l_list(new TStringList());
	UnicodeString ln_str;
	if (NyanFiForm->GrepPageControl->ActivePage==NyanFiForm->FindSheet) {
		ln_str.USET_T("͌");
		ln_str += conv_esc_char(InsStrWEdit->Text);
		ln_str.UCAT_T("}b`");
		ln_str += conv_esc_char(InsStrW2Edit->Text);
		ln_str.UCAT_T("łB");
	}
	else
		ln_str.USET_T("͒uʂ̃TvłB");
	ln_str.UCAT_T("\n2sڂłBsɃ^u͂܂B\n\t3sڂłBsɃ^u܂B");

	if (RepTabCheckBox->Checked) ln_str = REPLACE_TS(ln_str, "\t", " ");
	if (TrimLeftCheckBox->Checked) {
		TStringDynArray l_lst = SplitString(ln_str, "\n");
		ln_str = EmptyStr;
		for (int j=0; j<l_lst.Length; j++) {
			if (!ln_str.IsEmpty()) ln_str.UCAT_T("\n");
			ln_str += TrimLeft(l_lst[j]);
		}
	}

	if (RepCrCheckBox->Checked)
		ln_str = ReplaceStr(ln_str, "\n", conv_esc_char(RepCrEdit->Text));
	else
		ln_str = REPLACE_TS(ln_str, "\n", "\r\n");

	SampleMemo->Text = f_inf + ln_str;
}


//---------------------------------------------------------------------------
//obNAbv̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefBakBtnClick(TObject *Sender)
{
	UnicodeString dnam = GrepAppDir;
	if (UserModule->SelectDirEx(_T("obNAbv"), dnam)) RepBakDirEdit->Text = dnam;
}

//---------------------------------------------------------------------------
//Ot@C̎Q
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::RefLogBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("uOt@C̎w"), F_FILTER_TXT);
	UserModule->OpenDlgToEdit(LogFileEdit);
	SetFocus();
}
//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall TGrepExOptDlg::OkButtonClick(TObject *Sender)
{
	//Rg[̃^OɂĕύXKp
	ApplyOptionByTag(this);
}

//---------------------------------------------------------------------------
//wv
//---------------------------------------------------------------------------
bool __fastcall TGrepExOptDlg::FormHelp(WORD Command, NativeInt Data, bool &CallHelp)
{
	if (Command==HELP_CONTEXT || Command==HELP_CONTEXTPOPUP) {
		UnicodeString topic = (NyanFiForm->GrepPageControl->ActivePage==NyanFiForm->FindSheet)? HELPTOPIC_GR : HELPTOPIC_RP;
		topic.UCAT_T("#Option");
		HtmlHelpTopic(topic.c_str());
		CallHelp = false;
	}

	return true;
}
//---------------------------------------------------------------------------
